/*
 *  'UpdatesWarner' permits you to survey new versions
 *  Copyright (C) 2017-2021 Vincent Deca. known as Bigcake@ubuntu-fr.org
 *  (user@forum not email)
 *
 *  vincent.deca@neutralite.org
 *
 *  This file is part of 'UpdatesWarner'.
 *
 * 'UpdatesWarner' is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  'UpdatesWarner' is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 'UpdatesWarner'.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "../app.h"

const char      *English[] = {
  "Error", "Couldn't allocate enough memory"
  , "Unable to open file", "Missing lines in file"
  , "Print this help", "Unknown option" /* 5 */
  , "Load a language file", "Disable terminal colors"
  , "Print current version and quit", "Argument is missing for this option"
  , "Failed to initialize GTK library" /* 10 */
  , "_Quit", " Local version (manual): ", " Official version: "
  , "_Settings", "Settings" /* 15 */
  , "_Save", "C_ancel", " Vertical expand ", "Infos view expansion"
  , "To bottom" /* 20 */
  , "To top", "To left", "To right", " Maximal width ", " Maximal height " /* 25 */
  , "Main window", "Global settings", "Watchers"
  , "infosview_expansion: position of the information window, relative to the icon"
  , "Watcher" /* 30 */
  , "Name", "Enable", "_Add", "_Edit", "Remove" /* 35 */
  , " Lock position ", "Other options", "Show systray icon "
  , " Always on ", "top" /* 40 */
  , "bottom", "Adding a watcher", "Retrieving local version"
  , "Retrieving official version", " Name " /* 45 */
  , " Icon ", "Logo", "Move up", "Move down", "Logo choice" /* 50 */
  , "Manual version ", "Automatic version ", " !! Incomplete !! "
  , "containing"
  , "Unable to retrieve number of CPU cores" /* 55 */
  , "Unable to initialize thread attributs", "Unable to initialize a mutex"
  , "xxx_in_section: The version can be retrieved inside the nth section of the line"
    "Here, a section is surrounded by the 2 delimiters"
  , "In progress", "Not yet retrieved" /* 60 */
  , "Not enough words", "Unable to launch a command, fork() failed"
  , "Unable to launch a command, execv() failed", " Executable "
  , " Argument " /* 65 */
  , " from the end", "Command timed out"
  , "xxx_in_word: The version can be retrieved inside the nth word of the line"
  , "file is empty", "Sorry, file is too big for me" /* 70 */
  , "Unexpected character into configuration file", "Line"
  , "Missing element name", "Missing closing character ']'"
  , "Name is too long" /* 75 */
  , "Warning", "Missing parameter in section", "Unknown key name"
  , "Missing value", "A number is expected" /* 80 */
  , "Number is overflowing unsigned int max value"
  , "Number is out of parameter range", "Unknwon value for parameter"
  , "Missing closing character"
  , "max_width: To set the maximum count of icon in width" /* 85 */
  , "max_height: To set the maximum count of icon in height"
  , "vertical_expansion: if enable, icons will expand to the bottom then to the right"
  , "lock_position: if enable, the main window will not be movable with a simple mouse click"
  , "always_on: allow to keep main window on top of or behind other windows"
  , "always_on: keep main window on top other windows" /* 90 */
  , "always_on: keep main window behind other windows"
  , "systray: show the software icon in the systray system"
  , "infosview_expansion: the informations view will be shown to the bottom of the watcher"
  , "infosview_expansion: the informations view will be shown to the top of the watcher"
  , "infosview_expansion: the informations view will be shown to the left of the watcher" /* 95 */
  , "infosview_expansion: the informations view will be shown to the right of the watcher"
  , "This name is already used", "Update manual version"
  , "'exec' and/or 'arg' have been previously used, skipping parameter"
  , "'local_version' has been previously used, skipping parameter" /* 100 */
  , "version: Official version will be compared to this value"
  , "exec: Executable file launched to retrieve the local version"
  , "arg: Argument given to the executable to retrieve the local version"
  , "From the standard error output"
  , "stderr: Because some developers don't understand what 'stderr' stand for" /* 105 */
  , " In the resource, version can be retrieved", "Number is out of bounds"
  , " In line number ", " In the word number "
  , "xxx_in_word: Getting the nth word starting from end of line" /* 110 */
  , "Parameters to determine version"
    "Here, a word is a set of charactères separated by spaces"
  , "icon: To choose the image file which will represent the watcher"
  , "cut with ", " at position ", " HTTP header options " /* 115 */
  , "official_http_header: Options separated with comma. Override the header options ot the template"
  , "Invalid value", " Up-to-date: "
  , " URL ", "The URL has an unrecognized format" /* 120 */
  , "A delimiter specified is not permitted", " Delay between 2 checks"
  , " minutes", "official_timer: Delay, in minutes, between 2 resource download"
  , " Icons size " /* 125 */
  , "url: URL used to retrieve the web resource containing the official version"
  , "Unable to evaluate the cache file", "Missing mandatory element"
  , "xxx_in_line: Line count where to retrieve the official version from the web resource"
  , "xxx_in_line: Only the lines containing this word will count" /* 130 */
  , " In field number ", "Result of the search operations"
  , " Local version (auto): ", "Editing a watcher"
  , "Unable to load image file" /* 135 */
  , "Update local version", "Go to web site...", "Update official version"
  , "Retrieving local version with", "Retrieving official version from" /* 140 */
  , "The update timer has expired", "The downloaded file is empty"
  , "The cache file is not available", "Official version found"
  , "Activate verbose mode" /* 145 */
  , "Unable to save into config file"
  , "An error occured during writing into config file"
  , "Unable to launch application associated with this kind of URL"
  , "Unable to use transparency channel", " Background color " /* 150 */
  , "bg_color: to set the background color of the main window"
  , " Cache folder "
  , "cache_folder: folder containing downloaded web resources"
  , "An absolute path is required", "Unable to create folder" /* 155 */
  , "Already exists and is not a folder", "Unable to move folder"
  , "A problem occured with a GTK widget", "Unable to remove old folder"
  , "A problem occured when moving file" /* 160 */
  , "Format of value must be RRGGBBAA in hexadecimal"
  , "Format of value must be x,y (where ',' can also be ' ', '.', ':', '*', or '-'"
  , "xxx_in_section: Set the delimiters opening and closing the sections"
  , "Screen composite not available (= no transparency)"
  , "No output available from executable" /* 165 */
  , "xxx_in_word: To cut the word into multiple parts with a delimiter character"
  , "Local version found"
  , "xxx_in_word: To set the delimiter character"
  , "xxx_in_word: To specify the position of the version in the cut word"
  , "Trigger when..." /* 170 */
  , " delimited with ", "Work in Progress"
  , "Executable file is invalid"
  , " In section number ", "Unable to read file" /* 175 */
  , "Optionnal"
  , "optionnal: The watcher will be disable at start, if the executable is not available"
  , " Next update in ", "Unable to create a thread"
  , "Reload configuration" /* 180 */
  , "Loading configuration file", "Launch software"
  , "Invalid character in section name", "days", "hours" /* 185 */
  , "Missing name", "Missing official URL"
  , "Missing value of the 'In line' field"
  , "Missing delimiter character", "Missing executable with absolute path" /* 190 */
  , "Missing manual local version", "Retrieving official version"
  , "A problem occured when applying modifications"
  , "Switching cache folder to a fallback folder"
  , "Bytes count too high for the line, it will be shorten" /* 195 */
  , "You will have to create the cache folder yourself, because me... I give up..."
  , "...versions mismatch "
  , "Updating official version, manually requested", "Command output too large"
  , " In the command output, version can be retrieved " /* 200 */
  , "Update all official versions"
  , "Watcher cannot be removed while version update is in progress"
  , "trigger_on_mismatch: To trigger an action when a mismatch is detected between the official and local version"
  , "Entry is waiting an executable with absolute path. @name provides watcher's name, @local provides locale version, @official provides official version to the executable"
  , "About..." /* 205 */
  , "_Close", " Last version of UpdatesWarner can be found in the following URL:"
  , "_Edit Watcher", " After line containing "
  , "xxx_after_line: Version will be search only after the line containing this pattern" /* 210 */
  , "Missing value in the 'After line' block"
  , "Pattern not found", "...official version not found "
  , "trigger_on_error: To trigger an action official version is not found inside the web resource"
  , "Entry is waiting an executable with absolute path. @name provides watcher's name" /* 215 */
  , "Error... (updates-warner)", "_Okay"
  , "Some errors have been found in the configuration file.", "_Refresh systray"
  , "'cause some systray systems sux" /* 220 */
  , "Trigger on mismatch activated", "Trigger on error activated"
  , "Something went wrong when saving changes into configuration file"
  , "Adapatation to smartphone"
  , "Line must start with the string identifier" /* 225 */
  , "String identifier has already been used", "String identifier is too high"
  , "Unable to resize image", "Not enough lines in source"
  , "Not enough lines in source matching the pattern" /* 230 */
  , "Target field not found", "Result ", "Version found is empty"
  , "Add search block", "Too much search operation for watcher" /* 235 */
  , "Local version", "Key name is obsolete and will be replace"
  , "xxx_after_word: Version will be search only after this pattern"
  , " After word ", " number " /* 240 */
  , "xxx_in_field: The current line is split in sections with a chosen character"
  , "xxx_in_field: Set the character used to split the line"
  , "You probably forgot to export DISPLAY=:0"
  , "Unable to determine user home path, fallback to /tmp/uw_cache"
  , "Limit count of template reached" /* 245 */
  , "Too much search operation for template", "Use template"
  , " Using template ", "Template not found", "Network link is down" /* 250 */
  , "No network response (DNS error)", "A system call failed"
  , "Templates", "URL not resolved (DNS error)"
  , "Template" /* 255 */
  , " File to test template ", "Missing search block"
  , "Prints english table in the language file format"
  , "Adding a template", "Editing a template" /* 260 */
};

/*
   Purpose: Loading a langage file
*/
void                 Load_file_lang(const char *filename)
{
  FILE               *fd;
  char               **strs, *buffer;
  unsigned int       line, b, id_str, start;

  if(( fd = fopen( filename, "r" )) == NULL ) {
    ERR_SYS( "%s: %s", filename, app->Strs[2] ); /* "Unable to open file" */
    exit( EXIT_FAILURE );
  }

  CALLOC( strs, APP_NB_STRINGS, sizeof(*strs) );
  MALLOC( buffer, SIZE_BUFFER_LANG + 1 );

  /* Read file and fill strs table */
  buffer[SIZE_BUFFER_LANG] = '\0';
  for( line = 1; fgets( buffer, SIZE_BUFFER_LANG, fd ) != NULL; ++line ) {
    /* Allow comment */
    if( buffer[0] == '#' || buffer[0] == '\n' )
      continue;
    /* Line must start with number */
    if( buffer[0] < '0' || buffer[0] > '9' ) {
      ERR_APP( "%s: %s %u: %s", filename, app->Strs[72], line, app->Strs[225] ); /* "Line" "Line must start with the string identifier" */
      exit( EXIT_FAILURE );
    }
    /* Getting string ID */
    id_str = 0;
    for( b = 0; buffer[b] >= '0' && buffer[b] <= '9'; ++b ) {
      id_str *= 10;
      id_str += buffer[b] - '0';
    }
    if( id_str >= APP_NB_STRINGS ) {
      ERR_APP( "%s: %s %u: %s: %u > %u", filename, app->Strs[12], line, app->Strs[227], id_str, APP_NB_STRINGS - 1); /* "Line" "String identifier is too high" */
      exit( EXIT_FAILURE );
    }
    /* Delimiter */
    if( buffer[b] != ':' ) {
      ERR_APP( "%s: %s %u: %s", filename, app->Strs[12], line, app->Strs[14] ); /* "Line" "Delimiter ':' must follow string identifier" */
      exit( EXIT_FAILURE );
    }
    /* String */
    for( start = ++b; buffer[b] != '\n' && buffer[b] != '\0'; ++b ) {
      if( buffer[b] == '\\' ) {
        switch( buffer[b + 1] ) {
        case 'n': buffer[b] = '\n'; break;
        case 't': buffer[b] = '\t'; break;
        case '\\': buffer[b] = '\\'; break;
        }
        if( SIZE_BUFFER_LANG - b - 1 )
          memmove( &buffer[b + 1], &buffer[b + 2], SIZE_BUFFER_LANG - b - 1 );
      }
    }
    if( b > MAX_LANG_LINE_LENGTH ) {
      ERR_APP( "%s: %u > %u\n", app->Strs[195], b, MAX_LANG_LINE_LENGTH ); /* "Bytes count too high for the line, it will be shorten" */
      b = MAX_LANG_LINE_LENGTH;
    }
    buffer[b] = '\0';
    if( strs[id_str] ) {
      ERR_APP( "%s: %s %u: %s: %u", filename, app->Strs[72], line, app->Strs[226], id_str ); /* "Line" "String identifier has already been used" */
      exit( EXIT_FAILURE );
    }
    STRDUP( strs[id_str], &buffer[start] );
  }
  free( buffer );
  fclose( fd );

  /* If file does not contains all lines, fill missing ones with english table */
  for( line = 0; line < APP_NB_STRINGS; ++line )
    if( ! strs[line] ) {
      STRDUP( strs[line], English[line] );
      WARN_APP( "%s: %s: %u / %u: \"%s\"", filename, strs[3] ? strs[3] : app->Strs[3], line, APP_NB_STRINGS - 1, app->Strs[line] ); /* "Missing lines in file" */
    }

  /* Free tab if not English[] */
  if( app->Strs[0] != English[0] ) {
    for( line = 0; line < APP_NB_STRINGS; ++line )
      free( (void*) app->Strs[line] );
    free( (void*) app->Strs );
  }
  app->Strs = (const char**) strs;
}
