/*
 *  'UpdatesWarner' permits you to survey new versions
 *  Copyright (C) 2017-2021 Vincent Deca. known as Bigcake@ubuntu-fr.org
 *  (user@forum not email)
 *
 *  vincent.deca@neutralite.org
 *
 *  This file is part of 'UpdatesWarner'.
 *
 * 'UpdatesWarner' is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  'UpdatesWarner' is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 'UpdatesWarner'.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "../app.h"

/*
  Purpose: Creating and initialise an template structure
  - name : must be 0 or malloc'ed
*/
s_tpl                    *New_template(const char *name)
{
  GtkWidget              *hbox_main, *item;
  s_tpl                  *template;

  ASSERT( !name, "name = 0" );

  CALLOC( template, 1, sizeof(*template) );
  template->Name = name;

  hbox_main = APP_GTK_HBOX( FALSE, 0 );
  g_object_ref( G_OBJECT(hbox_main) );
  template->MainBox = hbox_main;

  Create_del_button( hbox_main );

  item = gtk_label_new( app->Strs[248] ); /* "Using template " */
  gtk_box_pack_start( GTK_BOX(hbox_main), item, FALSE, FALSE, 0 );

  item = gtk_entry_new();
  gtk_entry_set_text( GTK_ENTRY(item), name );
  gtk_widget_set_sensitive( item, 0 );
  gtk_box_pack_start( GTK_BOX(hbox_main), item, FALSE, FALSE, 0 );

  return( template );
}
